declare module "websnark/tools/stringifybigint" {
    export function stringifyBigInts(o: any): any;
    export function unstringifyBigInts(o: any): any;
    export function hexifyBigInts(o: any): any;
    export function unhexifyBigInts(o: any): any;
}
declare module "websnark/src/utils" {
    export function bigInt2BytesLE(_a: any, len: any): any[];
    export function bigInt2U32LE(_a: any, len: any): any[];
    export function toSolidityInput(proof: any): {
        proof: string;
    };
    export function genWitnessAndProve(groth16: any, input: any, circuitJson: any, provingKey: any): Promise<any>;
}
declare module "websnark/src/build_int" {
    function _exports(module: any, n64: any, _prefix: any): any;
    export = _exports;
}
declare module "websnark/src/build_f1m" {
    function _exports(module: any, _q: any, _prefix: any, _intPrefix: any): any;
    export = _exports;
}
declare module "websnark/src/build_f2m" {
    function _exports(module: any, pNonResidue: any, prefix: any, f1mPrefix: any): any;
    export = _exports;
}
declare module "websnark/src/build_f1" {
    function _exports(module: any, _q: any, _prefix: any, _f1mPrefix: any, _intPrefix: any): any;
    export = _exports;
}
declare module "websnark/src/build_timesscalar" {
    function _exports(module: any, fnName: any, elementLen: any, opAB: any, opAA: any, fPrefix: any): void;
    export = _exports;
}
declare module "websnark/src/build_curve" {
    function _exports(module: any, prefix: any, prefixField: any): any;
    export = _exports;
}
declare module "websnark/src/build_testg1" {
    function _exports(module: any): void;
    export = _exports;
}
declare module "websnark/src/build_fft" {
    function _exports(module: any, prefix: any, f1mPrefix: any, overrideNr: any): void;
    export = _exports;
}
declare module "websnark/src/build_multiexp" {
    function _exports(module: any, prefix: any, curvePrefix: any, pointFieldPrefix: any, scalarPrefix: any): void;
    export = _exports;
}
declare module "websnark/src/build_pol" {
    function _exports(module: any, prefix: any, prefixField: any): any;
    export = _exports;
}
declare module "websnark/src/bn128" {
    export = build;
    function build(): Promise<Bn128>;
    export class Bn128 {
        alloc(length: any): any;
        putInt(pos: any, _a: any): any;
        getInt(pos: any): bigInt.BigInteger;
        allocInt(_a: any): any;
        putIntF2(pos: any, a: any): void;
        getIntF2(pos: any): any[];
        allocIntF2(a: any): any;
        g1_putPoint(pos: any, p: any): void;
        g1_getPoint(pos: any): any[];
        g1_allocPoint(p: any): any;
        g2_putPoint(pos: any, p: any): void;
        g2_getPoint(pos: any): any[];
        g2_allocPoint(p: any): any;
        putBin(b: any): any;
        test_AddG1(n: any): number;
        test_fft(n: any): number;
    }
    import bigInt = require("big-integer");
}
declare module "src/build_mem" {
    function _exports(module: any, prefix: any, prefixField: any): any;
    export = _exports;
}
declare module "src/build_mulacc" {
    function _exports(windowSize: any, prefix: any, curvePrefix: any, scalarPrefix: any): void;
    export = _exports;
}
declare module "websnark/src/build_test" {
    export = buildTest;
    function buildTest(module: any, fn: any): void;
}
declare module "websnark/src/build_testf1" {
    function _exports(module: any): void;
    export = _exports;
}
declare module "websnark/src/build_tomcook" {
    function _exports(module: any, _prefix: any): void;
    export = _exports;
}
declare module "websnark/src/f1" {
    export = build;
    function build(q: any): Promise<F1>;
    export class F1 {
        alloc(length: any): any;
        putInt(pos: any, _a: any): any;
        allocInt(_a: any): any;
        putInt2(pos: any, _a: any): any;
        getInt(pos: any): bigInt.BigInteger;
        getInt2(pos: any): bigInt.BigInteger;
        allocInt2(_a: any): any;
        test_F1(n: any): number;
    }
    import bigInt = require("big-integer");
}
declare module "websnark/build/groth16_wasm" {
    export const code: any;
    export const pq: 1000;
    export const pr: 1768;
}
declare module "websnark/src/groth16" {
    export = build;
    function build(params: any): Promise<Groth16>;
    export class Groth16 {
        actionQueue: any[];
        postAction(workerId: any, e: any, transfers: any, _deferred: any): any;
        processWorks(): void;
        queueAction(actionData: any, transfers: any): any;
        alloc(length: any): any;
        putBin(p: any, b: any): void;
        getBin(p: any, l: any): any;
        bin2int(b: any): string;
        bin2g1(b: any): string[];
        bin2g2(b: any): string[][];
        g1_multiexp(scalars: any, points: any): Promise<any>;
        g2_multiexp(scalars: any, points: any): Promise<any>;
        g1_affine(p: any): any;
        g2_affine(p: any): any;
        g1_fromMontgomery(p: any): any;
        g2_fromMontgomery(p: any): any;
        loadPoint1(b: any): any;
        loadPoint2(b: any): any;
        terminate(): void;
        calcH(signals: any, polsA: any, polsB: any, nSignals: any, domainSize: any): Promise<any>;
        proof(signals: any, pkey: any): Promise<{
            pi_a: string[];
            pi_b: string[][];
            pi_c: string[];
        }>;
    }
}
declare module "websnark/src/protoboard" {
    export = buildProtoboard;
    function buildProtoboard(builder: any, defBytes: any, bitsPerBytes: any): Promise<Protoboard>;
    export class Protoboard {
        alloc(length: any): any;
        set(pos: any, nums: any, nBytes: any): any;
        get(pos: any, nElements: any, nBytes: any): bigInt.BigInteger | bigInt.BigInteger[];
    }
    import bigInt = require("big-integer");
}
declare module "websnark" {
    export const buildF1: typeof import("websnark/src/f1");
    export const buildBn128: typeof import("websnark/src/bn128");
    export const buildGroth16: typeof import("websnark/src/groth16");
}
//# sourceMappingURL=index.d.ts.map